<template>
  <div class="register lg:grid lg:grid-cols-12 lg:gap-x-5 max-w-7xl mx-auto px-4 sm:px-6 mt-6">
    <div class="bg-white overflow-hidden shadow rounded-lg divide-y divide-gray-200 col-span-9 mx-12">
      <div class="px-4 py-5 sm:px-6">
        <h3 class="text-lg leading-6 font-medium text-gray-900">
          {{currentStep && currentStep.title}}
        </h3>
      </div>
      <div class="px-4 py-5 sm:p-6">
        <Account v-if="currentStep && currentStep.order === 1" />
        <Profile v-else-if="currentStep && currentStep.order === 2" />
        <Business v-else-if="currentStep && currentStep.order === 3" />
        <Validation v-else />
      </div>
    </div>
    <Steps v-bind:steps="steps" class="fixed right-0 mr-16" />
  </div>
</template>

<script>
import Steps from '../../components/Steps/Steps'
import Profile from './Registration/Profile'
import Account from './Registration/Account'
import Business from './Registration/Business'
import Validation from './Registration/Validation'
import { mapActions } from 'vuex'

export default {
  name: 'Register',
  components: { Steps, Profile, Account, Business, Validation },
  computed: {
    steps () {
      return [
        { title: 'Create Account', description: 'Provide authentification information', status: this.$store.getters['auth/isLoggedIn'] ? 'completed' : 'current', order: 1 },
        { title: 'Profile Information', description: 'Complete your profile', status: !this.$store.getters['auth/isLoggedIn'] ? 'waiting' : this.$store.state.user.me?.status === 0 ? 'current' : this.$store.state.user.me?.status > 0 ? 'completed' : 'waiting', order: 2 },
        { title: 'Business Information', description: 'Fill in your company\'s information', status: !this.$store.getters['auth/isLoggedIn'] ? 'waiting' : this.$store.state.user.me?.status === 1 ? 'current' : this.$store.state.user.me?.status > 1 ? 'completed' : 'waiting', order: 3 },
        { title: 'Validation', description: 'An administrator is watching your request', status: !this.$store.getters['auth/isLoggedIn'] ? 'waiting' : this.$store.state.user.me?.status === 2 ? 'current' : this.$store.state.user.me?.status > 2 ? 'completed' : 'waiting', order: 4 }
      ]
    },
    currentStep: function () {
      return this.steps.find(step => step.status === 'current')
    }
  },
  methods: {
    ...mapActions('user', ['me'])
  },
  beforeMount () {
    this.me()
  },
  beforeUpdate () {
    this.me()
  }
}
</script>
